.\" Copyright (c) 2003
.\"	Bill Paul <wpaul@windriver.com>. All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. All advertising materials mentioning features or use of this software
.\"    must display the following acknowledgement:
.\"	This product includes software developed by Bill Paul.
.\" 4. Neither the name of the author nor the names of any co-contributors
.\"    may be used to endorse or promote products derived from this software
.\"   without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY Bill Paul AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL Bill Paul OR THE VOICES IN HIS HEAD
.\" BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
.\" CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
.\" SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
.\" CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
.\" ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF
.\" THE POSSIBILITY OF SUCH DAMAGE.
.\"
.\" $FreeBSD$
.\" $DragonFly: src/share/man/man4/re.4,v 1.6 2008/03/16 15:50:22 hasso Exp $
.\"
.Dd November 2, 2006
.Dt RE 4
.Os
.Sh NAME
.Nm re
.Nd "RealTek 8139C+/8169/816xS/811xS/8101E PCI/PCIe Ethernet adapter driver"
.Sh SYNOPSIS
.Cd "device miibus"
.Cd "device re"
.Pp
Alternatively, to load the driver as a module at boot time, place the
following line in
.Pa /boot/loader.conf :
.Bd -literal -offset indent
if_re_load="YES"
.Ed
.Sh DESCRIPTION
The
.Nm
driver provides support for various NICs based on the RealTek
RTL8139C+, RTL8169, RTL8169S, RTL8110S, RTL8168S, RTL8111S and RTL8101E
PCI and PCIe ethernet controllers.
.Pp
NICs based on the
8139C+ and 8101E
are capable of 10 and 100Mbps speeds over CAT5 cable.
NICs based on the
8169, 816xS and 811xS
are capable of 10, 100 and 1000Mbps operation.
.Pp
All NICs supported by the
.Nm
driver have TCP/IP checksum offload and hardware VLAN tagging/insertion
features, and use a descriptor-based DMA mechanism. They are also
capable of TCP large send (TCP segmentation offload).
.Pp
The 8139C+ is a single-chip solution combining both a 10/100 MAC and PHY.
The 8169 is a 10/100/1000 MAC only, requiring a GMII or TBI external PHY.
The 8169S and 8110S are single-chip devices containing both a 10/100/1000
MAC and 10/100/1000 copper PHY. Standalone 10/100/1000 cards are available
in both 32-bit PCI and 64-bit PCI models. The 8110S is designed for
embedded LAN-on-motherboard applications.
.Pp
The 8169, 8169S and 8110S also support jumbo frames, which can be configured
via the interface MTU setting.
Selecting an MTU larger than 1500 bytes with the
.Xr ifconfig 8
utility configures the adapter to receive and transmit jumbo frames.
.Pp
The
.Nm
driver supports the following media types:
.Bl -tag -width 10baseTXUTP
.It Cm autoselect
Enable autoselection of the media type and options.
The user can manually override
the autoselected mode by adding media options to
.Xr rc.conf 5 .
.It Cm 10baseT/UTP
Set 10Mbps operation.
The
.Xr ifconfig 8
.Ic mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 100baseTX
Set 100Mbps (fast ethernet) operation.
The
.Xr ifconfig 8
.Ic mediaopt
option can also be used to select either
.Cm full-duplex
or
.Cm half-duplex
modes.
.It Cm 1000baseT
Set 1000baseT operation over twisted pair.
The RealTek gigE chips support 1000Mbps in
.Cm full-duplex
mode only.
.\" .It Cm 1000baseSX
.\" Set 1000Mbps (gigabit ethernet) operation.
.\" Both
.\" .Cm full-duplex
.\" and
.\" .Cm half-duplex
.\" modes are supported.
.El
.Pp
The
.Nm
driver supports the following media options:
.Bl -tag -width full-duplex
.It Cm full-duplex
Force full duplex operation.
.It Cm half-duplex
Force half duplex operation.
.El
.Pp
For more information on configuring this device, see
.Xr ifconfig 8 .
.Ss MIB Variables
A number of per-interface variables are implemented in the
.Va hw.re Ns Em X
branch of the
.Xr sysctl 3
MIB.
.Bl -tag -width ".Va tx_moderation"
.It Va tx_moderation
Turn on (default) or off TX moderation.
.El
.Sh HARDWARE
The
.Nm
driver supports RealTek RTL8139C+, RTL8169, RTL816xS, RTL811xS,
and RTL8101E based Fast Ethernet and Gigabit Ethernet adapters including:
.Pp
.Bl -bullet -compact
.It
Alloy Computer Products EtherGOLD 1439E 10/100 (8139C+)
.It
Compaq Evo N1015v Integrated Ethernet (8139C+)
.It
Corega CG-LAPCIGT Gigabit Ethernet (8169S)
.It
D-Link DGE-528(T) Gigabit Ethernet (8169S)
.It
Gigabyte 7N400 Pro2 Integrated Gigabit Ethernet (8110S)
.It
LevelOne GNC-0105T (8169S)
.It
LinkSys EG1032 (32-bit PCI)
.It
PLANEX COMMUNICATIONS Inc.\& GN-1200TC (8169S)
.It
Xterasys XN-152 10/100/1000 NIC (8169)
.El
.Sh DIAGNOSTICS
.Bl -diag
.It "re%d: couldn't map ports"
A fatal initialization error has occurred.
.It "re%d: couldn't map interrupt"
A fatal initialization error has occurred.
.It "re%d: watchdog timeout"
The device has stopped responding to the network, or there is a problem with
the network connection (cable).
.El
.Sh SEE ALSO
.Xr arp 4 ,
.Xr ifmedia 4 ,
.Xr miibus 4 ,
.Xr netintro 4 ,
.Xr ng_ether 4 ,
.Xr polling 4 ,
.Xr vlan 4 ,
.Xr ifconfig 8
.Rs
.%T RealTek Semiconductor RTL8139C+, RTL8169, RTL8169S and RTL8110S datasheets
.%O http://www.realtek.com.tw
.Re
.Sh HISTORY
The
.Nm
device driver first appeared in
.Fx 5.2
and
.Dx 1.0 .
.Sh AUTHORS
The
.Nm
driver was written by
.An Bill Paul Aq wpaul@windriver.com .
.Sh BUGS
The Xterasys XN-152 32-bit PCI NIC, which uses the RTL8169 MAC and
Marvell 88E1000 PHY, has a defect that causes DMA corruption
if the board is plugged into a 64-bit PCI slot. The defect
lies in the board design, not the chip itself: the PCI REQ64# and ACK64#
lines should be pulled high, but they are not. The result is that the
8169 chip is tricked into performing 64-bit DMA transfers even though
a 64-bit data path between the NIC and the bus does not actually exist.
.Pp
Unfortunately, it is not possible to correct this problem in software,
however it is possible to detect it. When the
.Nm
driver is loaded, it will run a diagnostic routine designed to
validate DMA operation by placing the chip in digital loopback mode
and initiating a packet transmission. If the card functions properly,
the transmitted data will
be echoed back unmodified. If the echoed data is corrupt, the driver
will print an error message on the console and abort the device attach. The
user should insure the NIC is installed in a 32-bit PCI slot to
avoid this problem.
.Pp
The RealTek 8169, 8169S and 8110S chips appear to only be capable of
transmitting jumbo frames up to 7440 bytes in size.
